<?php

include_once('../global.php');
include_once('include.php');
RecalculateTariffs(1);

class FinanceUserState extends Page
{
  var $FullTitle = 'Stav financí účastníka';
  var $ShortTitle = 'Stav financí';

  function Show()
  {
    global $Tarify, $Sprava;

    if(!$this->System->Modules['User']->CheckPermission('Finance', 'DisplaySubjectState')) return('Nemáte oprávnění');

    $UserId = $this->System->Modules['User']->User['Id'];
    if(!array_key_exists('show', $_GET)) $_GET['show'] = '';
    $DbResult = $this->Database->query('SELECT Id FROM Subject WHERE Id=(SELECT Subject FROM Member WHERE Id=(SELECT Member FROM User WHERE Id='.$UserId.'))');
    $Subject = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT InternetTariffCurrentMonth FROM Member WHERE Id=(SELECT Member FROM User WHERE Id='.$UserId.')');
    $Member = $DbResult->fetch_assoc();
    $TarifName = $Tarify[$Member['InternetTariffCurrentMonth']]['name'];
	$TarifPrice = $Tarify[$Member['InternetTariffCurrentMonth']]['price'];
    $Output = '<table width="100%" border="0" cellspacing="0" cellpadding="3"><tr><td valign="top">';

    // Tabulka operaci
    $DbResult = $this->Database->query('SELECT CONCAT(SecondName, " ", FirstName) as Name FROM User WHERE Id='.$UserId);
    $User = $DbResult->fetch_assoc();
    $Output .= 'Výpis operací pro účastníka '.$User['Name'].':<br>';
    $Output .= '<table style="font-size: smaller;" border="1" cellspacing="0" cellpadding="3"><tr><th>Datum</th><th>Popis</th><th>Částka</th><th>Doklad</th></tr>';
    $Operations = array();
    $DbResult = $this->Database->query('(SELECT Time, Value, Text, Bill FROM FinanceCashFlow WHERE Subject='.$Subject['Id'].') UNION ALL '.
      '(SELECT TimeCreation as Time, -Value as Value, Text, Bill FROM FinanceClaimsLiabilities WHERE Subject='.$Subject['Id'].') ORDER BY Time DESC');
    while($DbRow = $DbResult->fetch_array())
      $Operations[] = $DbRow;
    foreach($Operations as $Row)
    {
      if($Row['Value'] == -0) $Row['Value'] = 0;
      if($Row['Value'] > 0) $Row['Value'] = '+'.$Row['Value'];
      if($Row['Bill'] > 0) $Invoice = '<a href="bill.php?Id='.$Row['Bill'].'">PDF</a>'; else $Invoice = '&nbsp;';
      $Output .= '<tr><td align="right">'.HumanDate($Row['Time']).'</td><td>'.$Row['Text'].'</td><td style="text-align: right;">'.$Row['Value'].'</td><td style="text-align: center;">'.$Invoice.'</td></tr>';
    }
    //echo('<tr><td>&nbsp;</td><td>-'.$Row2['network_device'].'</td><td>Proměnná cena za zařízení</td></tr>
    $Output .= '</table>';
    $DbResult = $this->Database->query('SELECT ((SELECT COALESCE(SUM(Value), 0) FROM FinanceCashFlow WHERE Subject='.$Subject['Id'].') + '.
      '(SELECT COALESCE(SUM(-Value), 0) FROM FinanceClaimsLiabilities WHERE Subject='.$Subject['Id'].')) as Total');
    $DbRow = $DbResult->fetch_array();
    $Total = $DbRow['Total'];
    $Output .= '<h3><strong>Stav účtu: </strong>'.$Total.' Kč</h3><br>';
    $Output .= '</td><td valign="top">';

    $Output .= 'Variabilní symbol pro platby: <strong>'.$Subject['Id'].'</strong><br><br>';

    $DbResult = $this->Database->query('SELECT SUM(consumption) AS Total FROM network_devices WHERE user='.$UserId.' AND used=1');
	$ConsumptionBonus = $DbResult->fetch_assoc();
	$ConsumptionBonus = W2Kc($ConsumptionBonus['Total']);

	$Total = 0;
    $Output .= 'Rozpis měsíčního poplatku:<br><table border="1" cellspacing="0" cellpadding="3">'.
      '<tr><th>Část</th><th>Cena [Kč]</th></tr>'.
      '<tr><td>Internet - tarif '.$TarifName.'</td><td>'.$TarifPrice.'</td></tr>';
	$Total += $TarifPrice;
	if($ConsumptionBonus != 0)
      $Output .= '<tr><td>Příjem za spotřebu</td><td>'.(-$ConsumptionBonus)  .'</td></tr>';
	$Total += -$ConsumptionBonus;
    $Output .= '<tr><td><strong>Celkem</strong></td><td><strong>'.$Total.'</strong></td></tr></table>';
    //echo('Tarif pro příští měsíc: '.$Tarify[$Row2['inet_tarif_next']]['name'].'<br><br>');
    $Output .= '<br />';
    
    if($ConsumptionBonus != 0)
    {
	  $Output .= 'Měsíční příjem za spotřebu zařízení umístěných u uživatele:<br>';
      $Output .= '<table border="1" cellspacing="0" cellpadding="3"><tr><th>Název zařízení</th><th>Spotřeba [W]</th><th>Příjem [Kč]</th></tr>';
      $DbResult = $this->Database->query('SELECT * FROM network_devices WHERE user='.$UserId.' AND used=1');
      $TotalW = 0;
      $TotalPrice = 0;
      while($Row = $DbResult->fetch_assoc())
      {
        $Output .= '<tr><td>'.$Row['name'].'</td><td>'.$Row['consumption'].'</td><td>'.W2Kc($Row['consumption']).'</td></tr>';
        $TotalW += $Row['consumption'];
        $TotalPrice += W2Kc($Row['consumption']);
      }
      $Output .= '<tr><td><strong>Celkem</strong></td><td><strong>'.$TotalW.'</strong></td><td><strong>'.$TotalPrice.'</strong></td></tr>';
      $Output .= '</table>';
	}
    $Output .= '</td></tr></table>';
    return($Output);
  }
}

$System->AddModule(new FinanceUserState());
$System->Modules['FinanceUserState']->GetOutput();

?>
